#ifndef _frequent_linear_hpp_
#define _frequent_linear_hpp_

#include "SAforMDBnaive.hpp"
#include "LCPmanzini.hpp"
#include "RMQ_n_1_alstrup.hpp"
#include "../globals.h"
#include <stdlib.h>
#include <iostream>
#include <stdio.h>
#include <stack>
#include <vector>

using namespace std;

class Node { // a (virtual) node in the (virtual) suffix tree:
public:
  int l;  // start-position in string
  int *s;

  Node(int, int *, int);
  ~Node() {
      delete [] s;
  }
};

/** 
 * Calculates frequent substrings with the optimal method.
 */
class FrequentStringsLinear {
public:
  // returns all strings that occurr >= min times in db1 and <= max times in db2
  void frequent(char*);

  // print string t[SA[p]..SA[p] + l - 1]
  void print(int*, unsigned char*, int, int);
};

#endif
