#ifndef _globals_h_
#define _globals_h_
#include <stdio.h>
#include <sys/mman.h>

void fatal_error(const char *);
extern const unsigned char SEPARATOR;
extern long long maxmem;
int MAX(int, int);
int MIN(int, int);
void change_mem(long long);
/* void generate_random_filename(char *s); */
int my_open(char *fname, int flags, int mode);
int open_truncate(char *prefix, char *dbname, char *fname, int size);
void my_close(int fd);
void close_unlink(int fd, char *fname);
int *my_mmap(int fd, int size, int mode);
void my_msync(void *ptr, int size);
void my_munmap(void *ptr, int size);
int *my_malloc(int size);
int *my_calloc(int n, int size);
void my_free(void *ptr, int size);
void print_progress(const char *s);

#endif
